#ifndef __SVLIB01_H
#define __SVLIB01_H

#ifndef __ASSOC_H
#include "assoc.h"
#endif

#ifndef __VELIB_H
#include "..\ve\velib.h"
#endif


class TStats_agg : public TObject
{
  enum TFrequenza_statistiche { fs_giornaliera, fs_settimanale, fs_quindicinale,
                                fs_mensile, fs_bimestrale, fs_trimestrale };

  class TStats_data : public TObject
  {    
  public:
    real _quantita, _valore;
  };

  TAssoc_array _data;
  
  TFrequenza_statistiche _frequenza;                       
  bool _merce, _prestazioni, _omaggi, _omaggio_is_merce;
  bool _agente, _cliente, _articolo, _giacenza, _magazzino;
  
protected: 
  // Converte una data nella classe temporale definita dalla frequenza delle statisitiche
  int date2class(const TDate& datadoc) const;
  TStats_agg::TStats_data& find(const TRiga_documento& rdoc);
  bool can_add(const TRiga_documento& rdoc) const;
  
public:   
  bool sub(const TRiga_documento& rdoc);
  bool add(const TRiga_documento& rdoc);
  bool update();

  TStats_agg();
  virtual ~TStats_agg() { }
};

#endif
